#!/usr/bin/env python
# -*- coding: utf-8 -*-
## Copyright (C) 2010 Bamacharan Kundu <bamachrn@gmail.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import bugz
import sqlite3
import os

usr_home = os.environ['HOME']
openzilla_dir = usr_home+'/.openzilla'
db_file_path = openzilla_dir+'/openzilla'
class openzillaSql:
    
    def __init__(self):
        if not os.path.exists(openzilla_dir):
            os.mkdir(openzilla_dir, 0755)
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        tables = []
        for x in c.execute('''select name from sqlite_master'''):
            tables.append(x[0])
        
        if not 'account_detail' in tables:
            c.execute('''create table account_detail (user_name text,password text,base text)''')
        
        if not 'bug_details' in tables:
            c.execute('''create table bug_details
            (bugid text, description text, bug_status text,assigned_to text,creation_ts date,delta_ts date,priority text,bug_severity text,resolution text,bug_file_loc text,reporter text,component text,product text,op_sys text,rep_platform text,status_whiteboard text,version text,target_milestone text,keywords text,attachment text,comments text)''')
        if not 'new_bug' in tables :
            c.execute('''create table new_bug
            (description text, bug_status text,assigned_to text,creation_ts date,delta_ts date,priority text,bug_severity text,resolution text,bug_file_loc text,reporter text,component text,product text,op_sys text,rep_platform text,status_whiteboard text,version text,keywords text,attachment text)''')
        
        conn.commit()
        c.close()
        self.me = ''
        print "db_init done"
    

    def account_check(self):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        acc_d = c.execute('''select user_name,password,base from account_detail''')
        acc_data = acc_d
        
        for data in acc_data:
            self.me = data[0]
            return data                
        
    
    def login(self,uname,password,base) :
        base = "https://bugzilla.redhat.com/"
        user = uname
        passwd = password
        forget = False
        always_auth = False
        #print a.authenticated
        self.acc = bugz.Bugz(base,user,passwd,forget,always_auth)
        print self.acc.authenticated
        self.acc.auth()
        print self.acc.authenticated
   
    def put_value(self,uname,password,base):
        base = base
        user = uname
        passwd = password
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        acc_trig = (user,passwd,base)
        self.me = user
        c.execute('''insert into account_detail values(?,?,?)''',acc_trig)
        conn.commit()
        c.close()
        
    def get_all_the_bugs(self,topic):
        model,result = self.acc.search(topic,order = 'number')
        result.reverse()
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        #result = range(10)
        bug_in_db = []
        bugid_id_db = c.execute('''select bugid from bug_details''')
        for row in bugid_id_db :
            bug_in_db.append(row[0])
        print bug_in_db    
        for bug in result : 
            bugid = bug['bugid']
            if bugid not in bug_in_db :
                print bugid
                bugdata = self.acc.get(bugid)
                print "data got"
                comment_detail = ""
                attachment = ''
                short_desc = ''
                assigned_to = ''
                creation_ts = ''
                delta_ts = ''
                bug_status = ''
                resolution = ''
                bug_file_loc = ''
                bug_severity = ''
                priority = ''
                target_milestone = ''
                reporter = ''
                rep_platform = ''
                op_sys = ''
                product = ''
                component = ''
                status_whiteboard = ''
                keywords = ''
                version = ''
                #///////////////////fields///////////////                
                try :                
                    short_desc = bugdata.find('//short_desc').text
                    assigned_to = bugdata.find('//assigned_to').text
                    creation_ts = bugdata.find('//creation_ts').text
                    delta_ts = bugdata.find('//delta_ts').text
                    bug_status = bugdata.find('//bug_status').text
                    resolution = bugdata.find('//resolution').text
                    bug_file_loc = bugdata.find('//short_desc').text
                    bug_severity = bugdata.find('//bug_severity').text
                    priority = bugdata.find('//priority').text
                    target_milestone = bugdata.find('//target_milestone').text
                    reporter = bugdata.find('//reporter').text
                    rep_platform = bugdata.find('//rep_platform').text
                    op_sys = bugdata.find('//op_sys').text
                    product = bugdata.find('//product').text
                    component = bugdata.find('//component').text
                    status_whiteboard = bugdata.find('//status_whiteboard').text
                    keywords = bugdata.find('//keywords').text
                    version = bugdata.find('//version').text
                except AttributeError:
                        #self.debug('Field not found: %s' % field)
                    print "error"
                
                #//////////////////////fields////////////////////
                
               #//////////////////////attachments////////////////////    
                try :
                    attachments = bugdata.findall('//attachment')
                    for attach in attachments:
                        aid = attach.find('.//attachid').text
                        desc = attach.find('.//desc').text
                        when = attach.find('.//date').text
                        attachment = attachment + '[%s] [%s] [%s]' % (aid,when,desc.encode('utf-8'))
                except AttributeError:
                        #self.debug('Field not found: %s' % field)
                    print "error"
                
               #///////////////////////////attachments///////////////////
               #////////////////////////comments//////////////////////
            
                linetext = bugdata.findall('//long_desc')
                i=0 
                for comment in linetext:
                    try:
                        who = comment.find('.//who').text.encode('utf-8')
                        when = comment.find('.//bug_when').text.encode('utf-8') 
                        what =  comment.find('.//thetext').text
                        list_text = ""
                        for line in what.split('\n'):
                            line = line.encode('utf-8')
                            list_text = list_text+'\n'+line
                      
                       #print list_text
                        comment_detail = comment_detail+'\n [Comment #%d ] %s %s : %s ' %(i,who,when,list_text)
                    
                    #print comment_detail
                    
                        i = i+1

                    except :
                        print "There is Error"
                   
                
                print comment_detail
            
            
                trigger = (bugid,short_desc, bug_status,assigned_to,creation_ts,delta_ts,priority,bug_severity,resolution,bug_file_loc,reporter,component,product,op_sys,rep_platform,version,status_whiteboard,target_milestone,keywords,attachment,comment_detail)
            
                c.execute('''insert into bug_details values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)''',trigger)
                conn.commit()
            else : 
                print "else"
            c.close()

    #def search_bug(self,data):
    
    def get_list(self,data) :
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        mybug = ["Assigned to Me","Priority"]
        mybug1 = ["Reported by Me","Status"]
        prio = ["Urgent","High","Medium","Low"]
        stat = ["NEW","ASSIGNED","MODIFIED","ON_DEV","ON_QA","VERIFIED","RELEASE_PENDING","POST","CLOSED"]
        requ = ["I Requested","I was Requested"]
        if data in prio :
            data = data.lower()
            tr = (data,self.me)
            bug_list = c.execute('''select bugid,bug_status,priority, assigned_to,description from bug_details where priority = ? and assigned_to = ?''',tr)
        elif data in stat :
            tr = (data,self.me)
            bug_list = c.execute('''select bugid,bug_status,priority, assigned_to,description from bug_details where bug_status = ? and reporter = ?''',tr)
        elif data in requ :
            tr = (data,)
            bug_list = c.execute('''select bugid,bug_status,priority, assigned_to,description from bug_details where bug_status = ?''',tr)
        elif data in mybug :
            tr = (self.me,)
            bug_list = c.execute('''select bugid,bug_status,priority, assigned_to,description from bug_details where assigned_to = ?''',tr)
        elif data in mybug1 :
            tr = (self.me,)
            bug_list = c.execute('''select bugid,bug_status,priority, assigned_to,description from bug_details where reporter = ?''',tr)
        else :
            bug_list = c.execute('''select bugid,bug_status,priority, assigned_to,description from bug_details''')
        
        result_list = bug_list
        return result_list
        #for ab in bug_list :
        #    return ab 
        
    def post(self, title, description, url='', assigned_to='', cc='', keywords=''):
          
        try:
            self.login(acc_test[0],acc_test[1],acc_test[2])
            try :
              bid = self.acc.post(title, description, url='', assigned_to='', cc='', keywords='')
              if bid == 0:
                conn = sqlite3.connect(db_file_path)
                conn.text_factory = str
                c =  conn.cursor()
                trigger = (title, description, '', assigned_to, cc, keywords)
                #trigger = (short_desc,bug_status,assigned_to,creation_ts,delta_ts,priority,bug_severity,resolution,bug_file_loc,reporter,component,product,op_sys,rep_platform,version,status_whiteboard,keywords,attachment)
                #c.execute('''insert into bug_details values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)''',trigger)
                conn.commit()
            except :
                time.sleep(120)
        except :
            self.save_bug(title, description, '', assigned_to,'', keywords)
            print "You are not authenticated"

    def save_bug(self, title, description, url='', assigned_to='', cc='', keywords=''):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        trigger = (title, description, '', assigned_to,'', keywords)
        #trigger =  (short_desc,bug_status,assigned_to,creation_ts,delta_ts,priority,bug_severity,resolution,bug_file_loc,reporter,component,product,op_sys,rep_platform,version,status_whiteboard,keywords,attachment)
        #c.execute('''insert into new_bug values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)''',trigger)
        print "Save_draft is clicked"
        conn.commit()
    def get_detail(self,bug_find_id):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        t = (bug_find_id,)
        bug_detail = c.execute('''select bugid,description,bug_status,assigned_to,creation_ts,delta_ts,priority,bug_severity,resolution,bug_file_loc,reporter,component,product,op_sys,rep_platform, status_whiteboard,target_milestone,keywords,attachment,comments from bug_details where bugid = ?''',t)
        bug_found =  bug_detail
        for bug_found_detail in bug_found: 
            return bug_found_detail            
    
    def get_version(self):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        bug_version = ""#c.execute('''select version from bug_details''')
        version =  bug_version
        versiondata = []
        for x in version:
            if x[0] != "" and x[0] not in versiondata:
              versiondata.append(x[0])
        return versiondata
    
    """def get_data(self,identity):
    conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        t = (identity,)
        bug_data = c.execute('''select ? from bug_details''',t)
        data_return =  bug_data
        searchdata = []
        for x in data_return : 
            if x[0] != "":
          searchdata.append(x[0])
        return searchdata
    
    """  
    def get_hardware(self):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        bug_hardware = c.execute('''select rep_platform from bug_details''')
        hardware =  bug_hardware
        hardwaredata = []
        for x in hardware : 
            if x[0] != "" and x[0] not in hardwaredata:
              hardwaredata.append(x[0])
        return hardwaredata
        
        
    def get_assigned_to(self):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        bug_assignee = c.execute('''select assigned_to from bug_details''')
        assignee =  bug_assignee
        assigneedata = []
        for x in assignee : 
            if x[0] != "" and x[0] not in assigneedata:
              assigneedata.append(x[0])
        return assigneedata

    def get_severity(self):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        bug_severity = c.execute('''select bug_severity from bug_details''')
        severity=  bug_severity
        severitydata = []
        for x in severity : 
            if x[0] != "" and x[0] not in severitydata:
              severitydata.append(x[0])
        return severitydata

    def get_op_sys(self):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        bug_op_sys = c.execute('''select op_sys from bug_details''')
        op_sys=  bug_op_sys
        op_sysdata = []
        for x in op_sys : 
            if x[0] != "" and x[0] not in op_sysdata:
              op_sysdata.append(x[0])
        return op_sysdata
    
    def get_component(self):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        bug_component = c.execute('''select component from bug_details''')
        component=  bug_component
        componentdata = []
        for x in component : 
            if x[0] != "" and x[0] not in componentdata:
              componentdata.append(x[0])
        return componentdata
    
    def get_product(self):
        conn = sqlite3.connect(db_file_path)
        conn.text_factory = str
        c =  conn.cursor()
        bug_product = c.execute('''select product from bug_details''')
        product=  bug_product
        productdata = []
        for x in product : 
            if x[0] != "" and x[0] not in productdata:
              productdata.append(x[0])
        return productdata

"""if __name__ == "__main__" :
    db = openzillaSql()
    db.login('username','password')
    db.db_init()
    db.get_all_the_bugs('nautilus')
    #db.get_list()"""
